package mon.stat

import scala.util.Random

import mon.battle.rngDice
import mon.stat.Target._

class Party(val trainer : TrainerID, var lead : Monster, var sideboard : IndexedSeq[Monster]) {
  def pollAction(implicit rng : Random) : Move = rng.pick(lead.base.moves)
  def pollTarget(move : Move, user : Monster, them: Party)(implicit rng : Random) : Monster = {
    if (move.target == Self) {
      user
    } else {
      them.lead
    }
  }
  
  def pollReplacement(them : Party)(implicit rng : Random) : Monster = {
    sideboard.filter(_.isAlive).head
  }
  
  def swapIn(mon : Monster) = {
    val index = sideboard.indexOf(mon)
    sideboard = sideboard.updated(index, lead)
    lead = mon
  }
  
  def canFight : Boolean = {
    lead.isAlive || sideboard.exists(_.isAlive)
  }
}